(*
Call by reference using memory cells.

fsharpc Mini.fs Effects/CallByRef.fs
mono CallByRef.exe

fsharpi Mini.fs Effects/CallByRef.fs
open Effects.CallByRef ;;
*)

module Effects.CallByRef

open Mini

let rec factorial (n : Nat, result : Ref<Nat>) =
  if n = 0N then
    result := 1N
  else
    factorial (n - 1N, result);
    result := !result * n

let main =
    print (let fac = ref 0N in factorial (10N, fac); !fac)
    
    let postOfficeBox = ref 10N
    factorial (!postOfficeBox, postOfficeBox)
    print (!postOfficeBox)
