(*

fsharpi Mini.fs Knobelaufgaben/Sort.fs

open Knobelaufgaben.Sort ;;

*)

module Knobelaufgaben.Sort

//let sort2 (a : Nat, b : Nat) : Nat * Nat =
let sort2 (a, b) =
  if a <= b then (a, b) else (b, a)

//let sort3 (a : Nat, b : Nat, c : Nat) : Nat * Nat * Nat =
let sort3 (a, b, c) =
  let  (min, max) = sort2 (a, b)
  in   if max <= c  then  (min, max, c)
                    else  if min <= c  then  (min, c, max)  
                                       else  (c, min, max)

//let sort5 (a : Nat, b : Nat, c : Nat, d : Nat, e : Nat) : Nat * Nat * Nat * Nat * Nat =
let sort5 (a, b, c, d, e) =
  let (a, b, c, d) =
        if a <= b then
          if c <= d  then  if b <= d  then (a, b, c, d)  else (c, d, a, b)
                     else  if b <= c  then (a, b, d, c)  else (d, c, a, b)
        else
          if c <= d  then  if a <= d  then (b, a, c, d)  else (c, d, b, a)
                     else  if a <= c  then (b, a, d, c)  else (d, c, b, a)
  // a <= b <= d und c <= d
  in  if b <= e then
        if d <= e then  // a <= b <= d <=e
          if b <= c  then (a, b, c, d, e)
                     else  if a <= c  then (a, c, b, d, e)  else (c, a, b, d, e)
        else            // a <= b <= e<= d
          if b <= c  then  if c <= e  then (a, b, c, e, d)  else (a, b, e, c, d)
                     else  if a <= c  then (a, c, b, e, d)  else (c, a, b, e, d)
      else
        if a <= e then  // a <= e <= b <= d
          if c <= e  then  if a <= c  then (a, c, e, b, d)  else (c, a, e, b, d)
                     else  if b <= c  then (a, e, b, c, d)  else (a, e, c, b, d)
        else            // e <= a <= b <=d
          if a <= c  then  if b <= c  then (e, a, b, c, d)  else (e, a, c, b, d)
                     else  if c <= e  then (c, e, a, b, d)  else (e, c, a, b, d)
