(*

fsharpi Mini.fs Values/Factorial.fs

open Values.Factorial ;;

*)

module Values.Factorial

open Mini

let rec factorialN (n : Nat) : Nat =
  if n = 0N then 1N
            else factorialN (n - 1N) * n

let rec factorial (n : int) : int =
  if n = 0 then 1
           else factorial (n - 1) * n

let rec factorialy (n : sbyte) : sbyte =
  if n = 0y then 1y
            else factorialy (n - 1y) * n

// [ for i in 1N .. 35N -> (i, factorialN i) ] ;;
// [ for i in 1 .. 35 -> (i, factorial i) ] ;;
// [ for i in 1y .. 10y -> (i, factorialy i) ] ;;
