module Algorithmics.Set

type Set<'elem when 'elem : comparison>

val empty    : Set<'elem>
val add      : 'elem * Set<'elem> -> Set<'elem>
val remove   : 'elem * Set<'elem> -> Set<'elem>
val isEmpty  : Set<'elem> -> bool
val contains : 'elem * Set<'elem> -> bool
val fromList : 'elem list -> Set<'elem>
val toList   : Set<'elem> -> 'elem list
