(*

fsharpi Mini.fs Datatypes/Array.fs

open Mini ;;
open Datatypes.Array ;;

*)

module Datatypes.Array

open Mini

// doesn't work without type annotations
let rec reverse<'a> (a : Array<'a>) =
  [| for i in 1 .. a.Length -> a.[a.Length - i] |]

let rec append<'a> (a : Array<'a>, b : Array<'a>) : Array<'a> =
  [| for i in 0 .. a.Length + b.Length - 1 ->
       if i < a.Length then a.[i]
                       else b.[i - a.Length]|]

// two-dimensional arrays
let my2DArray = array2D [ [1; 2]; [3; 4] ]
