(*

fsharpi Mini.fs Introduction/Arithmetic.fs
open Introduction.Arithmetic ;;

*)

module Introduction.Arithmetic

let rec ggt(m: Nat, n: Nat): Nat =
    if   m =  0N then n
    elif n =  0N then m
    elif m >= n  then ggt(m % n, n)
    else              ggt(m, n % m)

// es gilt: ggt (m, n) * kgv (m, n) = m * n

let kgv(m: Nat, n: Nat): Nat =
    (m * n) / ggt (m, n)

let main () =
    for i in 0N .. 9N do
        for j in 0N .. 9N do
            print (ggt (i, j))
