(*
Setter und Getter.

fsharpi Mini.fs Objects/Person.fs
open Objects.Person ;;
*)

module Objects.Person
#nowarn "62"

type Person =
    interface
        abstract member Name : String with get
        abstract member Age  : Nat    with get, set
    end

let doctor name alias age =
    let mutable age = age
    {
        new Person with
          member self.Name
            with get () = "Doctor " ^ name ^ if alias = "" then "" else " (aka " ^ alias ^ ")"
          member self.Age
            with get ()  = age
            and  set inc = age <- age + inc
    }        

(*
let dolittle = doctor "Dolittle" "King Jong Thinkalot" 42N ;;
dolittle.Name ;;
dolittle.Age <- 2N ;;
dolittle.Age ;;
*)   
