(*
Classes implementing multiple interfaces.

fsharpi Objects/Turncoat.fs
open Objects.Turncoat ;;
*)

module Objects.Turncoat

type IPositive =
    abstract Answer : string
type INegative =
    abstract Answer : string

type Undecided () =
    class
        member self.Answer = "maybe"
        interface IPositive with
            member self.Answer = "yup"
        interface INegative with
            member self.Answer = "nope"
    end

let turncoat = Undecided ()

// turncoat.Answer ;;
// val it : string = "maybe"
// (turncoat :> IPositive).Answer ;;
// val it : string = "yup"
// (turncoat :> INegative).Answer ;;
// val it : string = "nope"
