(*

fsharpi Mini.fs Values/Game.fs

open Values.Game ;;

*)

module Values.Game

open Mini

// Ist die gesuchte Zahl kleiner gleich als die geratene?

let playerA (guess : Nat) : bool  =  
  4711N <= guess

let linearSearch (oracle : Nat -> bool, lower : Nat, upper : Nat) : Nat =
    let rec search (n : Nat) : Nat =
      if n >= upper then upper
      else if oracle n then  n
                       else  search (n + 1N)
    search lower

let chattyplayerA (secret : Nat) (guess : Nat) : bool =
  putline ("Geratene Zahl: " + show guess);
  secret <= guess

print (linearSearch (chattyplayerA 471N, 0N, 999N))

let binarySearch (oracle : Nat -> Bool, lower : Nat, upper : Nat) : Nat =
  let rec search (l : Nat, u : Nat) : Nat =
    if l >= u then u
    else  let  m = (l + u) / 2N
          in   if oracle m  then  search (l,       m)
                            else  search (m + 1N,  u)
  in search (lower, upper)

print (binarySearch (chattyplayerA 471N, 0N, 999N))

let playerB = linearSearch

let square (n : Nat) : Nat = n * n

let squareRoot (n : Nat) : Nat =
   binarySearch ((fun k -> n < square (k + 1N)), 0N, n)

// squareRoot 4711N ;;
